//
//  ListProductsInteractor.swift
//  shuup
//
//  Created by Yeison Vargas on 3/15/19.
//  Copyright (c) 2019 Rokk3rlabs. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit

protocol ListProductsBusinessLogic
{
  func fetchProducts(request: ListProducts.FetchProducts.Request)
  func updateStock(request: ListProducts.UpdateStock.Request)
}

protocol ListProductsDataStore
{
  //var name: String { get set }
}

class ListProductsInteractor: ListProductsBusinessLogic, ListProductsDataStore
{
  var presenter: ListProductsPresentationLogic?
  var worker: ProductsWorker?

  var products: [Product]?
  
  // MARK: Do something
  
  func fetchProducts(request: ListProducts.FetchProducts.Request)
  {
    worker = ProductsWorker(productsStore: ProductMemStore())
    worker?.fetchProducts(completionHandler: { (products) in
        self.products = products
        let response = ListProducts.FetchProducts.Response(products: self.products!)
        self.presenter?.presentProducts(response: response)
    })
  }

  func updateStock(request: ListProducts.UpdateStock.Request) {

    var stock = Int(request.product.stock)!

    if request.remove {
        stock = stock - 1
    } else {
        stock = stock + 1
    }

    var removeFromSale = false

    if stock < 1 {
        removeFromSale = true
    }

    let response = ListProducts.UpdateStock.Response(product: request.product, currentStock: stock,
                                                     removeFromSale: removeFromSale)
    self.presenter?.presentProductUpdate(response: response)
  }


}
